#include "../shared.h"
#include "randomnumbers.h"
#include "program.h"

__kernel void clear( write_only image2d_t outimg )
{
	int x = get_global_id( 0 );
	int y = get_global_id( 1 );
	if ((x >= SCRWIDTH) || (y >= SCRHEIGHT)) return;
	write_imagef( outimg, (int2)(x, y), 0 );
}

__kernel void update( global float* balls )
{
	int idx = get_global_id( 0 );
	balls[idx * 6 + 0] += balls[idx * 6 + 2];
	balls[idx * 6 + 1] += balls[idx * 6 + 3];
}

__kernel void render( write_only image2d_t outimg, global float* balls )
{
	int x = get_global_id( 0 );
	int y = get_global_id( 1 );
	if ((x >= SCRWIDTH) || (y >= SCRHEIGHT)) return;
	float2 uv = { (float)x / SCRWIDTH, (float)y / SCRHEIGHT };
	// draw balls
	for( int i = 0; i < BALLCOUNT; i++ )
	{
		float2 pos = { balls[i * 6], balls[i * 6 + 1] };
		float dist = length( pos - uv );
		if (dist < 0.02f)
		{
			write_imagef( outimg, (int2)(x, (SCRHEIGHT - 1) - y), (float4)(1,0,0,1) );
			break;
		}
	}
}